﻿package 
{
	import flash.display.Bitmap;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.external.ExternalInterface;
	import flash.geom.ColorTransform;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.ui.Mouse;
	import flash.utils.getTimer;	
	/**
	 * ...
	 * @author Niek Albers nieka@daansystems.com
	 */
	public class Main extends Sprite 
	{
		
		[Embed(source="../lib/Carbon Block.ttf", fontName="Carbon Block")]
		public var font:Class;

		[Embed(source="../lib/compass.png")] 
		public var compassClass:Class;
		public var compass:Sprite;

		[Embed(source="../lib/pointer.png")] 
		public var pointerClass:Class;
		public var pointer:Bitmap;
		
		
		public var t0:uint;
		public var frameCounter:uint = 0;
		public var debugText:TextField;
		public static var instance:Main;
		
		public function Main():void 
		{
			instance = this;
			init();
		}	
		
		public function init(e:Event = null):void 
		{
			this.addEventListener(Event.ENTER_FRAME, onEnterFrame);
			
			addMenuButton("Continue", "continue", 0, 100);
			addMenuButton("Settings", "settings", 0, 140);
			addMenuButton("Exit", "exit", 0, 180);
			addSlider("slider here", "slider", 0, 220);
			addCompass();
			addDebugTextField();
			
			pointer = new pointerClass();
			addChild(pointer);
			
			Mouse.hide();
			
			if (ExternalInterface.available) {
				ExternalInterface.addCallback("compass", setCompass );
			}
	
		}
		
		public function addSlider(caption:String, action:String, x:Number, y:Number):MenuSlider {
			var slider:MenuSlider = new MenuSlider("Brightness","brightness");
			slider.y = y;
			addChild(slider);
			return slider;
		}
		
		public function addMenuButton(caption:String, action:String, x:Number, y:Number):MenuButton {
			var menuButton:MenuButton = new MenuButton(caption,action);
			menuButton.y = y;
			addChild(menuButton);
			return menuButton;
		}
		
		public function addCompass():void {
			
			compass = new Sprite;
			var compassBitmap:Bitmap = new compassClass;			
			compass.addChild(compassBitmap);
			compassBitmap.x -= compassBitmap.width / 2;
			compassBitmap.y -= compassBitmap.height / 2;
			
			this.compass.x = 300;
			this.compass.y = 300;
			this.addChild(this.compass);
					
		}
		
		public function addDebugTextField():void {
			debugText = new TextField();
			var tf:TextFormat = new TextFormat("Carbon Block", 18);
			
			debugText.embedFonts = true;
			debugText.defaultTextFormat = tf;
			debugText.y = 200;
			debugText.textColor = 0x00ff00;
			debugText.background = true;
			debugText.backgroundColor = 0xff0000;
			debugText.mouseEnabled = false;
			debugText.autoSize = TextFieldAutoSize.LEFT;
			debugText.text = "log: ";
			addChild(debugText);	
		}
		
		public function setCompass(arg:String):void {
			this.compass.rotation = parseInt(arg);
		}
		
		public function onEnterFrame(evt:Event):void {
			if (frameCounter == 0) t0 = getTimer();
			var t:int = getTimer();
			var fraction:Number = (t - t0) / 1000;
			t0 = t;
			
			for (var i:uint = 0; i < this.numChildren; i++) {
				var d:DisplayObject = this.getChildAt(i);
				if (d is MenuItem) Object(d).advance(fraction);
			}
			
			pointer.x = mouseX;
			pointer.y = mouseY;
			frameCounter++;
		}
		
		static public function clamp(a_Value:Number, a_Min:Number, a_Max:Number):Number {
			return Math.max(Math.min(a_Value, a_Max), a_Min);
		}	
		
		public function trace(what:String):void {
			if (debugText.height > 150) debugText.text = "";
			debugText.appendText(what+"\n");
		}
	}
	
}