﻿package  
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.external.ExternalInterface;
	import flash.geom.ColorTransform;
	import flash.text.TextField;
	import mx.effects.easing.*;

	/**
	 * ...
	 * @author Niek
	 */
	public class MenuItem extends Sprite
	{
		public var action:String;
		public var caption:String;
		public var elapsed:Number = 0;
		public var colorTransform:ColorTransform = new ColorTransform();
		public var deltaX:Number = 0;
		public var target:Number = 30;
		public var currentVal:Number = 0;
		public var text:TextField;
		import flash.text.AntiAliasType;
		import flash.text.Font;
		import flash.text.TextField;
		import flash.text.TextFieldAutoSize;
		import flash.text.TextFormat;
		
		public function MenuItem(caption:String,action:String) 
		{
			this.caption = caption;
			this.action = action;
			
			text = new TextField();
			var format:TextFormat = new TextFormat("Carbon Block", 30);
			format.letterSpacing = 2;
			text.defaultTextFormat = format;
			text.textColor = 0xffffff;
			text.autoSize = TextFieldAutoSize.LEFT;
			text.mouseEnabled = false;
			text.antiAliasType = AntiAliasType.ADVANCED;
			text.embedFonts = true;
			text.text = caption;
			addChild(text);			
			
			this.addEventListener(MouseEvent.MOUSE_MOVE, onMouseMove);
			this.addEventListener(MouseEvent.ROLL_OVER, onMouseOver);
			this.addEventListener(MouseEvent.ROLL_OUT, onMouseOut);
			this.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			this.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			this.addEventListener(MouseEvent.CLICK, onMouseClick);
			draw();
			centerX();
		}
		
		public function draw():void {
			graphics.clear();
			graphics.lineStyle(2, 0x0000ff);
			graphics.beginFill(0x0000aa);
			graphics.drawRect(0, 0, 200, 30);
			graphics.endFill();	
			
		}

		public function centerX():void {
			this.x = Main.instance.stage.stageWidth / 2 - this.width / 2;
		}
		public function onMouseMove(evt:MouseEvent):void {
			
		}

		
		public function onMouseOver(evt:MouseEvent):void {
			deltaX = 1;
			elapsed = 0;
		}
		
		public function onMouseOut(evt:MouseEvent):void {
			deltaX = -1;
			elapsed = 0;
			colorTransform.redOffset = 0;
			colorTransform.greenOffset = 0;
		}
	
		public function onMouseDown(evt:MouseEvent):void {
			colorTransform.redOffset = 100;
			colorTransform.greenOffset = 100;
		}
			
		public function onMouseUp(evt:MouseEvent):void {
			colorTransform.redOffset = 0;
			colorTransform.greenOffset = 0;		
		}

		public function onMouseClick(evt:MouseEvent):void {
			Main.instance.trace("clicked: " + action);
		}
		
		public function advance(fraction:Number):void {
			elapsed += fraction;
			currentVal = Linear.easeInOut(elapsed * 100, currentVal, target * deltaX, 250);
		 	currentVal = Main.clamp(currentVal, 0, target);	
			colorTransform.blueMultiplier = currentVal / target;
			colorTransform.alphaMultiplier = currentVal / target + 0.7;
			this.transform.colorTransform = colorTransform;
			
		}		
	}

}