﻿package 
{
	import flash.display.Bitmap;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.external.ExternalInterface;
	import flash.filters.BlurFilter;
	import flash.filters.GlowFilter;
	import flash.geom.ColorTransform;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.ui.Mouse;
	import flash.utils.getTimer;	
	/**
	 * ...
	 * @author Niek Albers nieka@daansystems.com
	 */
	public class Main extends Sprite 
	{
		
		[Embed(source="../lib/Carbon Block.ttf", fontName="Carbon Block")]
		public var font:Class;

		[Embed(source="../lib/compass.png")] 
		public var compassClass:Class;
		public var compass:Sprite;

		public var title:TextField;
		
		public var t0:uint;
		public var frameCounter:uint = 0;
		public static var instance:Main;
		public static var delta:Number = -0.01;
		
		public function Main():void 
		{
			instance = this;
			init();
		}	
		
		public function init(e:Event = null):void 
		{
			this.addEventListener(Event.ENTER_FRAME, onEnterFrame);
			addTitle();
			addCompass();
					
			Mouse.hide();
			
			if (ExternalInterface.available) {
				ExternalInterface.addCallback("compass", setCompass );
			}
	
		}
				
		public function addTitle():void {
			
			title = new TextField();
			var tf:TextFormat = new TextFormat("Carbon Block", 18);
			
			title.embedFonts = true;
			title.defaultTextFormat = tf;
			title.textColor = 0xff0000;
			title.mouseEnabled = false;
			title.autoSize = TextFieldAutoSize.LEFT;
			title.text = "Flash Compass";
			
			addChild(title);
			
		}
		
		public function addCompass():void {
			compass = new Sprite;
			var compassBitmap:Bitmap = new compassClass;			
			compass.addChild(compassBitmap);
			compassBitmap.x -= compassBitmap.width / 2;
			compassBitmap.y -= compassBitmap.height / 2;
			
			this.compass.x = this.stage.stageWidth / 2;
			this.compass.y = this.stage.stageHeight / 2;
			this.addChild(this.compass);
			
		}
				
		public function setCompass(arg:String):void {
			this.compass.rotation = parseInt(arg);
		}
		
		public function onEnterFrame(evt:Event):void {
			compass.rotation++;
			compass.scaleX += delta;
			compass.scaleY += delta;
			if (compass.scaleX < 0 || compass.scaleX > 1) delta = -delta; 	
			
			if(this.frameCounter % 50 == 0)	graphics.clear();
			graphics.lineStyle(1, Math.random() * 0xFFFFFF );
			graphics.drawCircle(Math.random() * stage.stageWidth, Math.random() * stage.stageHeight, Math.random() * 5);
			
			this.frameCounter++;
		}
		
	}
	
}