// Horde3D Render flash to Texture by Niek Albers niek@daansystems.com
// v0.3

#pragma once

#include "Horde3D.h"
#include <windows.h>

#ifndef DLL
#define DLL extern "C" __declspec( dllimport )
#endif

typedef char* (*H3DFLASH_CALLBACK_PROC)(char *cmd, char *args, void *userdata);

// for getting a pointer to the Horde3DFlash object, for C++ usage
class Horde3DFlash;
DLL Horde3DFlash *h3dfGetHorde3DFlash( H3DRes textureRes );

// Create Horde3D texture
DLL H3DRes h3dfCreateTexture( char *name, int width, int height );

// Create Horde3D flash render instance on a texture resource
DLL BOOL h3dfCreate( H3DRes textureRes, int left, int top, int right, int bottom, char *flashVars );

// Remove a texture and cleanup flash buffer
DLL BOOL h3dfRemoveTexture( H3DRes textureRes );

// Load a SWF from a file
DLL BOOL h3dfLoadFromFile( H3DRes textureRes, char *filename );

// Load a SWF from memory
DLL BOOL h3dfLoadFromMemory( H3DRes textureRes, void *data, unsigned int length);

// Send mousemove to the flash container
DLL BOOL h3dfSendMouseMove( H3DRes textureRes, int x, int y);

// Send mousedown to the flash container
DLL BOOL h3dfSendMouseDown(H3DRes textureRes) ;

// Send mouseup to the flash container
DLL BOOL h3dfSendMouseUp(H3DRes textureRes) ;

// Send any windows message to the flash container
DLL LRESULT h3dfSendMessage( H3DRes textureRes, UINT msg, WPARAM wParam, LPARAM lParam) ;

// Render all defined flash textures
DLL BOOL h3dfRender() ;

// forward all window messages from wnd to the flash container
DLL BOOL h3dfForwardWindowEvents( H3DRes textureRes, HWND wnd) ;

// Set a flash variable
DLL BOOL h3dfSetVariable( H3DRes textureRes, char *name, char *value) ;

// Call a flash function as defined by ExternalInterface.addCallback(...)
DLL char *h3dfCallFunction(H3DRes textureRes, char *name, char *args);

// Set a callback for fscommand and ExternalInterface.call(..) 
DLL BOOL h3dfSetCallBack(H3DRes textureRes, H3DFLASH_CALLBACK_PROC proc, void *userdata);

// Play the loaded movie
DLL BOOL h3dfPlay(H3DRes textureRes);

// Stop the loaded movie
DLL BOOL h3dfStop(H3DRes textureRes); 

// Utility function to find the main application window
DLL HWND h3dfGetAppWindow();